<?php
/**
 * @author Amasty Team
 * @copyright Copyright (c) 2016 Amasty (https://www.amasty.com)
 * @package Mageplace_Gallery
 */

/**
 * Class Mageplace_Gallery_Model_Settings
 */
class Mageplace_Gallery_Model_Settings extends Varien_Object
{
    /**
     * @var Mageplace_Gallery_Helper_Config
     */
    protected $_configHelper;
    protected $_configData = array();
    protected $_group;


    protected function _construct()
    {
        $this->_configHelper = Mage::helper('mpgallery/config');
    }

    public function setGroup($group)
    {
        $this->_group = $group;

        return $this;
    }

    public function getData($key = '', $group = null)
    {
#        Mage::log($key);
        if(array_key_exists($key, $this->_configData)) {
            return $this->_configData[$key];
        }

        $data = parent::getData($key);
#        Mage::log($data);
        if (null === $data) {
            $data = $this->_configHelper->find($key, null !== $group ? $group : $this->_group);
#           Mage::log($data);
        }

        $this->_configData[$key] = $data;

        return $data;
    }
}
