<?php
class Ameex_Insurance_UpdateController extends Mage_Adminhtml_Controller_Action
{
	public function indexAction()
	{
		$companyIds = $this->getRequest()->getParam('company_id');
		Mage::getSingleton('adminhtml/session')->setCompanyIds(serialize($companyIds));
		$this->loadLayout();		
		$this->_setActiveMenu('insurance/create_companies');
		$this->_addContent($this->getLayout()->createBlock('ameex_insurance/adminhtml_company_updateFormContainer'))
			 ->_addLeft($this->getLayout()->createBlock('ameex_insurance/adminhtml_company_updateFormContainer_edit_tabs'));
        $this->renderLayout();
	}
	
	public function saveAction()
	{
		$params = $this->getRequest()->getParams();
		$companyIds = unserialize($params['company_ids']);
		$ordersPerCycle = $params['orders_per_cycle'];
		$email = $params['email'];
		$status = $params['status'];
		$model = Mage::getModel("ameex_insurance/company");
		try {
			foreach($companyIds as $companyId) {
				$model->load($companyId);
				if(isset($ordersPerCycle) && ($ordersPerCycle != ""))
					$model->setOrdersPerCycle($ordersPerCycle);
				if(isset($email) && ($email != ""))
					$model->setEmail($email);
				if(isset($status) && ($status != ""))
					$model->setStatus($status);
				$model->save();
			}
			Mage::getSingleton('adminhtml/session')->addSuccess(
					Mage::helper('ameex_insurance')->__('Total of %d record(s) were updated.', count($companyIds))
				);
		}
		catch(Exception $e) {
			Mage::getSingleton('adminhtml/session')->addError($e->getMessage());
		}
		$this->_redirect('*/company/index');
	}
}
