<?php
class Ameex_Insurance_Block_Adminhtml_Reports_OrderItems_GridContainer_Grid extends Mage_Adminhtml_Block_Widget_Grid
{
	public function __construct()
	{
		parent::__construct();
		$this->setId('orderItems');
		$this->setUseAjax(true);		
		$this->setDefaultSort('created_at');
		$this->setDefaultDir('DESC');
		$this->setSaveParametersInSession(true);
	}

	protected function _prepareCollection()
	{
		$collection = Mage::getModel('ameex_insurance/companyOrderItem')->getCollection();
		$collection->getSelect()->joinLeft(
				Mage::getConfig()->getTablePrefix().'insurance_companies',
				'main_table.company_id ='.Mage::getConfig()->getTablePrefix().'insurance_companies.id',
				array('email')
        );
		$collection->getSelect()->joinLeft(
				Mage::getConfig()->getTablePrefix().'sales_flat_order_item',
				'main_table.order_item_id ='.Mage::getConfig()->getTablePrefix().'sales_flat_order_item.item_id',
				array('sku','price','order_id','name')
        );
		$collection->getSelect()->joinLeft(
				Mage::getConfig()->getTablePrefix().'sales_flat_order',
				Mage::getConfig()->getTablePrefix().'sales_flat_order_item.order_id ='.Mage::getConfig()->getTablePrefix().'sales_flat_order.entity_id',
				array('increment_id')
        );
        $collection->setOrder('created_at','DESC');
		$this->setCollection($collection);
		return parent::_prepareCollection();
	}
    
   protected function _prepareColumns()
   {
		$options = Mage::getModel('ameex_insurance/options');
		
		$this->addColumn('assigned_on', array(
            'header' => Mage::helper('sales')->__('Assigned On'),
            'index' => 'created_at',
            'filter_index' => 'main_table.created_at',
            'type' => 'datetime',
        ));
		
		$this->addColumn('order_id', array(
					'header' => Mage::helper('ameex_insurance')->__('Order #'),
					'index' => 'increment_id',
			   ));

		$this->addColumn('product_name', array(
					'header' => Mage::helper('ameex_insurance')->__('Product Name'),
					'index'	 => 'name',
					'filter_index' => 'sales_flat_order_item.name',
			   ));

		$this->addColumn('sku', array(
					'header' => Mage::helper('ameex_insurance')->__('SKU'),
					'index'	 => 'sku',
			   ));

		$this->addColumn('email', array(
					'header' => Mage::helper('ameex_insurance')->__('Company Email'),
					'index'	 => 'email',
			   ));

		$this->addColumn('company_name', array(
					'header' => Mage::helper('ameex_insurance')->__('Company Name'),
					'type'      => 'options',
					'options'    => $options->getCompanies(),
					'index' => 'company_id',
					'totals_label' => 'Total'
			   ));
			   
		if (Mage::getSingleton('admin/session')->isAllowed('sales/order/actions/view')) {
            $this->addColumn('view_order',
                array(
                    'header'    => Mage::helper('ameex_insurance')->__('Go To Order'),
                    'type'      => 'action',
                    'filter'    => false,
                    'sortable'  => false,
                    'renderer'  => 'Ameex_Insurance_Block_Adminhtml_Reports_OrderItems_GridContainer_Grid_Renderers_ViewOrderAction',
                    'is_system' => true,
                    'totals_label' => ''
            ));
        }

		$this->addColumn('view_company',
			array(
				'header'    => Mage::helper('ameex_insurance')->__('Go To Company'),
				'type'      => 'action',
				'filter'    => false,
				'sortable'  => false,
				'renderer'  => 'Ameex_Insurance_Block_Adminhtml_Reports_OrderItems_GridContainer_Grid_Renderers_ViewCompanyAction',
				'is_system' => true,
				'totals_label' => ''
		));

		$this->addExportType('*/*/exportCsv', Mage::helper('ameex_insurance')->__('CSV'));

		return parent::_prepareColumns();
    }

	public function getGridUrl()
    {
        return $this->getUrl('*/*/grid', array('_current'=>true));
    }
}
