<?php
 


class Limex_Advr_Block_Adminhtml_Order_Category
    extends Limex_Advr_Block_Adminhtml_Order_Abstract
{
    public function _prepareLayout()
    {
        parent::_prepareLayout();
        
        $this->setHeaderText(Mage::helper('advr')->__('Sales By Category'));

        return $this;
    }

    protected function _prepareChart()
    {
        $this->setChartType('pie');

        $this->_initChart()
            ->setNameField('category_name')
            ->setValueField('sum_grand_total')
            ;

        return $this;
    }

    protected function _prepareGrid()
    {
        $this->_initGrid()
            ->setDefaultLimit(100000)
            ->setPagerVisibility(false)
            ;

        return $this;
    }

    public function _prepareCollection()
    {
        $collection = Mage::getModel('advr/report_sales')
            ->setBaseTable('catalog/category')
            ->setFilterData($this->getFilterData())
            ->selectColumns($this->getVisibleColumns())
            ->groupByColumn('category_id')
            ;

        return $collection;
    }

    public function getColumns()
    {
        $columns = array(
            'category_level' => array(
                'header'           => 'Level',
                'type'             => 'number',
                'sortable'         => false,
            ),

            'category_name' => array(
                'header'              => 'Category',
                'frame_callback'      => array(Mage::helper('advr/callback'), 'category'),
                'chart'               => true,
                'sortable'            => false,
            ),

            'category_path' => array(
                'header'            => 'Category Path',
                'frame_callback'    => array(Mage::helper('advr/callback'), 'categoryPath'),
                'sortable'          => false,
                'hidden'            => true
            )
        );

        $columns += $this->getOrderTableColumns();

        return $columns;
    }

    public function getTotals()
    {
        return false;
    }
}