<?php

require '../vendor/autoload.php';

use \SixBySix\RealtimeDespatch\Api\Credentials;
use SixBySix\RealtimeDespatch\Gateway\Factory\DefaultGatewayFactory;

$credentials = new Credentials();
$credentials->setEndpoint('https://getsquare.realtimedespatch.co.uk/web/');
$credentials->setChannel('magento');
$credentials->setOrganisation('myco');
$credentials->setUsername('magento');
$credentials->setPassword('magento');

$factory = new DefaultGatewayFactory();
$service = new SixBySix\RealtimeDespatch\Service\ProductService($factory->create($credentials));

try
{
    // Success
    $product = new SixBySix\RealtimeDespatch\Entity\Product();
    $product->setExternalReference('UniCharge35');
    $product->setDescription('A new test description. '.uniqid());
    $product->setParam('uniqueParam', 'uniqueValue');

    $importReport = $service->updateProduct($product);

    foreach ($importReport->getLines() as $line) {
        echo $line->getMessage()."\n";
    }

    // Failure
    $product = new SixBySix\RealtimeDespatch\Entity\Product();
    $product->setExternalReference('UniCharge37');

    $importReport = $service->updateProduct($product);

    foreach ($importReport->getLines() as $line) {
        echo $line->getMessage()."\n";
    }
}
catch (Exception $ex)
{
    var_dump($ex->getMessage());
}